<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/value_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
.textRainbow_lv0_p1 { color: #add8e6; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>04/20/82  value_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>The value_ subroutine reads and maintains value segments containing
<span id="L4" class="LineNr">  4 </span>name-value pairs.
<span id="L5" class="LineNr">  5 </span>
<span id="L6" class="LineNr">  6 </span>
<span id="L7" class="LineNr">  7 </span>Entry points in value_:
<span id="L8" class="LineNr">  8 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>
<span id="L11" class="LineNr"> 11 </span>:Entry: defined:  07/16/81  value_$defined
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>Function:  returns &quot;1&quot;b if a value is defined for name, &quot;0&quot;b otherwise.
<span id="L15" class="LineNr"> 15 </span>
<span id="L16" class="LineNr"> 16 </span>
<span id="L17" class="LineNr"> 17 </span>Syntax:
<span id="L18" class="LineNr"> 18 </span>dcl value_$defined entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> bit <span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L19" class="LineNr"> 19 </span>     returns <span class="textRainbow_lv0_p0">(</span>bit <span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L20" class="LineNr"> 20 </span>defined_sw = value_$defined <span class="textRainbow_lv0_p0">(</span>seg_ptr<span class="textRainbow_lv0_o0">,</span> switches<span class="textRainbow_lv0_o0">,</span> name<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L21" class="LineNr"> 21 </span>
<span id="L22" class="LineNr"> 22 </span>
<span id="L23" class="LineNr"> 23 </span>Arguments:
<span id="L24" class="LineNr"> 24 </span>seg_ptr
<span id="L25" class="LineNr"> 25 </span>   is a pointer to the base of a value segment.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>  See &quot;Notes&quot;.
<span id="L26" class="LineNr"> 26 </span>switches
<span id="L27" class="LineNr"> 27 </span>   is a bit <span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span> aligned word of switches: <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L28" class="LineNr"> 28 </span>     perprocess
<span id="L29" class="LineNr"> 29 </span>        looks for a perprocess value, as opposed to one stored in any
<span id="L30" class="LineNr"> 30 </span>        value segment.  Either this switch or &quot;permanent&quot; must be on.
<span id="L31" class="LineNr"> 31 </span>        If both switches are on, a perprocess value is returned if one
<span id="L32" class="LineNr"> 32 </span>        exists, otherwise a value stored in the value segment is
<span id="L33" class="LineNr"> 33 </span>        returned.
<span id="L34" class="LineNr"> 34 </span>     permanent
<span id="L35" class="LineNr"> 35 </span>        looks for a value stored in the value segment.
<span id="L36" class="LineNr"> 36 </span>
<span id="L37" class="LineNr"> 37 </span>
<span id="L38" class="LineNr"> 38 </span>name
<span id="L39" class="LineNr"> 39 </span>   is a character string with at least one nonblank character.
<span id="L40" class="LineNr"> 40 </span>   Trailing blanks are trimmed. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L41" class="LineNr"> 41 </span>code
<span id="L42" class="LineNr"> 42 </span>   is a standard status code. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L43" class="LineNr"> 43 </span>
<span id="L44" class="LineNr"> 44 </span>
<span id="L45" class="LineNr"> 45 </span>Access required:
<span id="L46" class="LineNr"> 46 </span>r on the value segment, except for perprocess values.
<span id="L47" class="LineNr"> 47 </span>
<span id="L48" class="LineNr"> 48 </span>
<span id="L49" class="LineNr"> 49 </span>Notes: To initialize a new value segment, create a segment with suffix
<span id="L50" class="LineNr"> 50 </span>&quot;value&quot; and call value_$init_seg with a pointer to its base.  If
<span id="L51" class="LineNr"> 51 </span>seg_ptr is null, the default value segment is used, which is initially
<span id="L52" class="LineNr"> 52 </span><span class="textRainbow_lv0_p1">[</span>home_dir<span class="textRainbow_lv0_p1">]</span>&gt;<span class="textRainbow_lv0_p1">[</span>user name<span class="textRainbow_lv0_p1">]</span>.value but can be changed by value_$set_path or
<span id="L53" class="LineNr"> 53 </span>the value_set_path <span class="textRainbow_lv0_p0">(</span>vsp<span class="textRainbow_lv0_p0">)</span> command.
<span id="L54" class="LineNr"> 54 </span>
<span id="L55" class="LineNr"> 55 </span>
<span id="L56" class="LineNr"> 56 </span>:Entry: delete:  07/16/81  value_$delete
<span id="L57" class="LineNr"> 57 </span>
<span id="L58" class="LineNr"> 58 </span>
<span id="L59" class="LineNr"> 59 </span>Function:  this entry point causes there to be no value defined for
<span id="L60" class="LineNr"> 60 </span>name.
<span id="L61" class="LineNr"> 61 </span>
<span id="L62" class="LineNr"> 62 </span>
<span id="L63" class="LineNr"> 63 </span>Syntax:
<span id="L64" class="LineNr"> 64 </span>dcl value_$delete entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> bit <span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L65" class="LineNr"> 65 </span>call value_$delete <span class="textRainbow_lv0_p0">(</span>seg_ptr<span class="textRainbow_lv0_o0">,</span> switches<span class="textRainbow_lv0_o0">,</span> name<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L66" class="LineNr"> 66 </span>
<span id="L67" class="LineNr"> 67 </span>
<span id="L68" class="LineNr"> 68 </span>Arguments:
<span id="L69" class="LineNr"> 69 </span>seg_ptr
<span id="L70" class="LineNr"> 70 </span>   is a pointer to the base of a value segment. If seg_ptr is null, the
<span id="L71" class="LineNr"> 71 </span>   default value segment is used, which is initially:
<span id="L72" class="LineNr"> 72 </span>          <span class="textRainbow_lv0_p1">[</span>home_dir<span class="textRainbow_lv0_p1">]</span>&gt;<span class="textRainbow_lv0_p1">[</span>user name<span class="textRainbow_lv0_p1">]</span>.value
<span id="L73" class="LineNr"> 73 </span>   but can be changed by value_$set_path or the value_set_path <span class="textRainbow_lv0_p0">(</span>vsp<span class="textRainbow_lv0_p0">)</span>
<span id="L74" class="LineNr"> 74 </span>   command. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L75" class="LineNr"> 75 </span>switches
<span id="L76" class="LineNr"> 76 </span>   is a bit <span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span> aligned word of switches <span class="textRainbow_lv0_p0">(</span>perprocess or permanent<span class="textRainbow_lv0_p0">)</span>.
<span id="L77" class="LineNr"> 77 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L78" class="LineNr"> 78 </span>name
<span id="L79" class="LineNr"> 79 </span>   is a character string with at least one nonblank character.
<span id="L80" class="LineNr"> 80 </span>   Trailing blanks are trimmed. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L81" class="LineNr"> 81 </span>code
<span id="L82" class="LineNr"> 82 </span>   is a standard status code. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L83" class="LineNr"> 83 </span>
<span id="L84" class="LineNr"> 84 </span>
<span id="L85" class="LineNr"> 85 </span>Access required:
<span id="L86" class="LineNr"> 86 </span>rw on the value segment, except for perprocess values.
<span id="L87" class="LineNr"> 87 </span>
<span id="L88" class="LineNr"> 88 </span>
<span id="L89" class="LineNr"> 89 </span>:Entry: get:  07/16/81  value_$get
<span id="L90" class="LineNr"> 90 </span>
<span id="L91" class="LineNr"> 91 </span>
<span id="L92" class="LineNr"> 92 </span>Function:  returns the defined value of a name.
<span id="L93" class="LineNr"> 93 </span>
<span id="L94" class="LineNr"> 94 </span>
<span id="L95" class="LineNr"> 95 </span>Syntax:
<span id="L96" class="LineNr"> 96 </span>dcl value_$get entry options <span class="textRainbow_lv0_p0">(</span>variable<span class="textRainbow_lv0_p0">)</span>;
<span id="L97" class="LineNr"> 97 </span>call value_$get <span class="textRainbow_lv0_p0">(</span>seg_ptr<span class="textRainbow_lv0_o0">,</span> switches<span class="textRainbow_lv0_o0">,</span> name<span class="textRainbow_lv0_o0">,</span> value_arg<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L98" class="LineNr"> 98 </span>
<span id="L99" class="LineNr"> 99 </span>
<span id="L100" class="LineNr">100 </span>Arguments:
<span id="L101" class="LineNr">101 </span>seg_ptr
<span id="L102" class="LineNr">102 </span>   is a pointer to the base of a value segment. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L103" class="LineNr">103 </span>switches
<span id="L104" class="LineNr">104 </span>   is a bit <span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span> aligned word of switches <span class="textRainbow_lv0_p0">(</span>perprocess or permanent<span class="textRainbow_lv0_p0">)</span>.
<span id="L105" class="LineNr">105 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L106" class="LineNr">106 </span>name
<span id="L107" class="LineNr">107 </span>   is a fixed-length or varying character string.  If fixed-length,
<span id="L108" class="LineNr">108 </span>   trailing blanks are trimmed.  There must be at least one character.
<span id="L109" class="LineNr">109 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L110" class="LineNr">110 </span>
<span id="L111" class="LineNr">111 </span>
<span id="L112" class="LineNr">112 </span>value_arg
<span id="L113" class="LineNr">113 </span>   is the returned value, having any data type.  If conversion from the
<span id="L114" class="LineNr">114 </span>   internal character string representation cannot be performed,
<span id="L115" class="LineNr">115 </span>   error_table_$bad_conversion is returned.  Conversion errors cannot
<span id="L116" class="LineNr">116 </span>   occur if value_arg is a character string, but if it has a maxlength
<span id="L117" class="LineNr">117 </span>   &gt; 0, the error code error_table_$smallarg is returned if truncation
<span id="L118" class="LineNr">118 </span>   occurs. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L119" class="LineNr">119 </span>code
<span id="L120" class="LineNr">120 </span>   is a standard error code.  It is error_table_$oldnamerr <span class="textRainbow_lv0_p0">(</span>&quot;Name not
<span id="L121" class="LineNr">121 </span>   found.&quot;<span class="textRainbow_lv0_p0">)</span> if no value is defined. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L122" class="LineNr">122 </span>
<span id="L123" class="LineNr">123 </span>
<span id="L124" class="LineNr">124 </span>Access required:
<span id="L125" class="LineNr">125 </span>r access to the value segment, except for perprocess values.
<span id="L126" class="LineNr">126 </span>
<span id="L127" class="LineNr">127 </span>
<span id="L128" class="LineNr">128 </span>Notes:  Perprocess values are stored in a temporary value segment in
<span id="L129" class="LineNr">129 </span>the process directory, and disappear when the process terminates.
<span id="L130" class="LineNr">130 </span>
<span id="L131" class="LineNr">131 </span>
<span id="L132" class="LineNr">132 </span>:Entry: get_data:  07/16/81  value_$get_data
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span>
<span id="L135" class="LineNr">135 </span>Function:  returns, into a caller-supplied buffer, the region of
<span id="L136" class="LineNr">136 </span>storage that is defined as the value of a name, as set by either
<span id="L137" class="LineNr">137 </span>value_$set_data or value_$test_and_set_data.  Values set by other
<span id="L138" class="LineNr">138 </span>entrypoints are not seen by value_$get_data.
<span id="L139" class="LineNr">139 </span>
<span id="L140" class="LineNr">140 </span>
<span id="L141" class="LineNr">141 </span>Syntax:
<span id="L142" class="LineNr">142 </span>dcl value_$get_data entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> bit <span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L143" class="LineNr">143 </span>     fixed bin <span class="textRainbow_lv1_p0">(</span>18<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L144" class="LineNr">144 </span>call value_$get_data <span class="textRainbow_lv0_p0">(</span>seg_ptr<span class="textRainbow_lv0_o0">,</span> switches<span class="textRainbow_lv0_o0">,</span> name<span class="textRainbow_lv0_o0">,</span> area_ptr<span class="textRainbow_lv0_o0">,</span> data_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L145" class="LineNr">145 </span>     data_size<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L146" class="LineNr">146 </span>
<span id="L147" class="LineNr">147 </span>
<span id="L148" class="LineNr">148 </span>Arguments:
<span id="L149" class="LineNr">149 </span>seg_ptr
<span id="L150" class="LineNr">150 </span>   is a pointer to the base of a value segment. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L151" class="LineNr">151 </span>switches
<span id="L152" class="LineNr">152 </span>   is a bit <span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span> aligned word of switches <span class="textRainbow_lv0_p0">(</span>perprocess or permanent<span class="textRainbow_lv0_p0">)</span>.
<span id="L153" class="LineNr">153 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L154" class="LineNr">154 </span>name
<span id="L155" class="LineNr">155 </span>   is a character string with at least one nonblank character.
<span id="L156" class="LineNr">156 </span>   Trailing blanks are trimmed. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L157" class="LineNr">157 </span>area_ptr
<span id="L158" class="LineNr">158 </span>   points to an area in which the value can be allocated. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L159" class="LineNr">159 </span>data_ptr
<span id="L160" class="LineNr">160 </span>   points to the value returned. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L161" class="LineNr">161 </span>
<span id="L162" class="LineNr">162 </span>
<span id="L163" class="LineNr">163 </span>data_size
<span id="L164" class="LineNr">164 </span>   is the number of words in the value.  If it is greater than
<span id="L165" class="LineNr">165 </span>   buffer_size, only buffer_size words are returned, data_size is set
<span id="L166" class="LineNr">166 </span>   to the full size of the value, and error_table_$smallarg is
<span id="L167" class="LineNr">167 </span>   returned. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L168" class="LineNr">168 </span>code
<span id="L169" class="LineNr">169 </span>   is a standard error code.  It is error_table_$oldnamerr <span class="textRainbow_lv0_p0">(</span>&quot;Name not
<span id="L170" class="LineNr">170 </span>   found.&quot;<span class="textRainbow_lv0_p0">)</span> if no value is defined. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L171" class="LineNr">171 </span>
<span id="L172" class="LineNr">172 </span>
<span id="L173" class="LineNr">173 </span>Access required:
<span id="L174" class="LineNr">174 </span>r on the value segment, except for perprocess values.
<span id="L175" class="LineNr">175 </span>
<span id="L176" class="LineNr">176 </span>
<span id="L177" class="LineNr">177 </span>Notes:  Perprocess values are stored in a temporary value segment in
<span id="L178" class="LineNr">178 </span>the process directory, and disappear when the process terminates.
<span id="L179" class="LineNr">179 </span>
<span id="L180" class="LineNr">180 </span>
<span id="L181" class="LineNr">181 </span>:Entry: get_path:  07/16/81  value_$get_path
<span id="L182" class="LineNr">182 </span>
<span id="L183" class="LineNr">183 </span>
<span id="L184" class="LineNr">184 </span>Function:  returns the pathname of the current default value segment
<span id="L185" class="LineNr">185 </span>used by value commands without -pathname.
<span id="L186" class="LineNr">186 </span>
<span id="L187" class="LineNr">187 </span>
<span id="L188" class="LineNr">188 </span>Syntax:
<span id="L189" class="LineNr">189 </span>dcl value_$get_path entry <span class="textRainbow_lv0_p0">(</span>char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L190" class="LineNr">190 </span>call value_$get_path <span class="textRainbow_lv0_p0">(</span>path<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L191" class="LineNr">191 </span>
<span id="L192" class="LineNr">192 </span>
<span id="L193" class="LineNr">193 </span>Arguments:
<span id="L194" class="LineNr">194 </span>path
<span id="L195" class="LineNr">195 </span>   is the pathname. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L196" class="LineNr">196 </span>code
<span id="L197" class="LineNr">197 </span>   is a standard status code. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L198" class="LineNr">198 </span>
<span id="L199" class="LineNr">199 </span>
<span id="L200" class="LineNr">200 </span>:Entry: init_seg:  07/16/81  value_$init_seg
<span id="L201" class="LineNr">201 </span>
<span id="L202" class="LineNr">202 </span>
<span id="L203" class="LineNr">203 </span>Function:  initializes a segment to be a value segment.
<span id="L204" class="LineNr">204 </span>
<span id="L205" class="LineNr">205 </span>
<span id="L206" class="LineNr">206 </span>Syntax:
<span id="L207" class="LineNr">207 </span>dcl value_$init_seg entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>19<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L208" class="LineNr">208 </span>     fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L209" class="LineNr">209 </span>call value_$init_seg <span class="textRainbow_lv0_p0">(</span>seg_ptr<span class="textRainbow_lv0_o0">,</span> seg_type<span class="textRainbow_lv0_o0">,</span> remote_area_ptr<span class="textRainbow_lv0_o0">,</span> seg_size<span class="textRainbow_lv0_o0">,</span>
<span id="L210" class="LineNr">210 </span>     code<span class="textRainbow_lv0_p0">)</span>;
<span id="L211" class="LineNr">211 </span>
<span id="L212" class="LineNr">212 </span>
<span id="L213" class="LineNr">213 </span>Arguments:
<span id="L214" class="LineNr">214 </span>seg_ptr
<span id="L215" class="LineNr">215 </span>   is a pointer to a segment. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L216" class="LineNr">216 </span>seg_type
<span id="L217" class="LineNr">217 </span>   determines the type of use to which the value segment will be put,
<span id="L218" class="LineNr">218 </span>   and therefore the method of allocating values: <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L219" class="LineNr">219 </span>   0    permanent:  shareable by multiple processes and therefore
<span id="L220" class="LineNr">220 </span>        locked when modified, with values always stored in the value
<span id="L221" class="LineNr">221 </span>        segment itself.
<span id="L222" class="LineNr">222 </span>   1    perprocess:  for use only by the calling process and therefore
<span id="L223" class="LineNr">223 </span>        never locked, with values optionally stored in an area outside
<span id="L224" class="LineNr">224 </span>        the &quot;value segment&quot; <span class="textRainbow_lv0_p0">(</span>see the remote_area_ptr argument below<span class="textRainbow_lv0_p0">)</span>.
<span id="L225" class="LineNr">225 </span>
<span id="L226" class="LineNr">226 </span>
<span id="L227" class="LineNr">227 </span>remote_area_ptr
<span id="L228" class="LineNr">228 </span>   for a perprocess segment only, points to an area outside the value
<span id="L229" class="LineNr">229 </span>   segment in which values are to be allocated.  For example, the
<span id="L230" class="LineNr">230 </span>   &quot;value segment&quot; can be a region of storage 72 words long consisting
<span id="L231" class="LineNr">231 </span>   only of a header, and remote_area_ptr can point to the user's own
<span id="L232" class="LineNr">232 </span>   area.  If remote_area_ptr is null and seg_type is 1, values are
<span id="L233" class="LineNr">233 </span>   allocated in the system free area. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L234" class="LineNr">234 </span>seg_size
<span id="L235" class="LineNr">235 </span>   is the number of words available to the value segment, or to the
<span id="L236" class="LineNr">236 </span>   remote area if remote_area_ptr is nonnull.  If seg_size is 0, the
<span id="L237" class="LineNr">237 </span>   available size is an entire segment. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L238" class="LineNr">238 </span>code
<span id="L239" class="LineNr">239 </span>   is a standard status code. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L240" class="LineNr">240 </span>
<span id="L241" class="LineNr">241 </span>
<span id="L242" class="LineNr">242 </span>Access required:
<span id="L243" class="LineNr">243 </span>rw on the segment.
<span id="L244" class="LineNr">244 </span>
<span id="L245" class="LineNr">245 </span>
<span id="L246" class="LineNr">246 </span>:Entry: delete_data: 04/20/82  value_$delete_data
<span id="L247" class="LineNr">247 </span>
<span id="L248" class="LineNr">248 </span>Syntax:
<span id="L249" class="LineNr">249 </span>dcl value_$delete_data entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> bit <span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L250" class="LineNr">250 </span>
<span id="L251" class="LineNr">251 </span>call value_$delete_data <span class="textRainbow_lv0_p0">(</span>seg_ptr<span class="textRainbow_lv0_o0">,</span> switches<span class="textRainbow_lv0_o0">,</span> name<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L252" class="LineNr">252 </span>
<span id="L253" class="LineNr">253 </span>
<span id="L254" class="LineNr">254 </span>Function: deletes values set by value_$set_data.
<span id="L255" class="LineNr">255 </span>
<span id="L256" class="LineNr">256 </span>
<span id="L257" class="LineNr">257 </span>Arguments:
<span id="L258" class="LineNr">258 </span>seg_ptr
<span id="L259" class="LineNr">259 </span>   is a pointer to the base of a value segment. If seg_ptr is null, the
<span id="L260" class="LineNr">260 </span>   default value segment is used, which is initially:
<span id="L261" class="LineNr">261 </span>          <span class="textRainbow_lv0_p1">[</span>home_dir<span class="textRainbow_lv0_p1">]</span>&gt;<span class="textRainbow_lv0_p1">[</span>user name<span class="textRainbow_lv0_p1">]</span>.value
<span id="L262" class="LineNr">262 </span>   but can be changed by value_$set_path or the value_set_path <span class="textRainbow_lv0_p0">(</span>vsp<span class="textRainbow_lv0_p0">)</span>
<span id="L263" class="LineNr">263 </span>   command. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L264" class="LineNr">264 </span>switches
<span id="L265" class="LineNr">265 </span>   is a bit <span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span> aligned word of switches:  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L266" class="LineNr">266 </span>     perprocess
<span id="L267" class="LineNr">267 </span>       deletes a perprocess value, as opposed to one stored in any
<span id="L268" class="LineNr">268 </span>       value segment. Either this switch or &quot;permanent&quot; must be on.
<span id="L269" class="LineNr">269 </span>       If both switches are on, the perprocess value is deleted if one
<span id="L270" class="LineNr">270 </span>       exists, otherwise the value in the value segment is deleted.
<span id="L271" class="LineNr">271 </span>     permanent
<span id="L272" class="LineNr">272 </span>       deletes a value stored in the value segment.
<span id="L273" class="LineNr">273 </span>name
<span id="L274" class="LineNr">274 </span>   is a character string with at least one nonblank character.
<span id="L275" class="LineNr">275 </span>   Trailing blanks are trimmed. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L276" class="LineNr">276 </span>code
<span id="L277" class="LineNr">277 </span>   is a standard status code. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L278" class="LineNr">278 </span>
<span id="L279" class="LineNr">279 </span>
<span id="L280" class="LineNr">280 </span>Access required:  rw on the value segment, except for perprocess values.
<span id="L281" class="LineNr">281 </span>
<span id="L282" class="LineNr">282 </span>
<span id="L283" class="LineNr">283 </span>:Entry: list:  07/16/81  value_$list
<span id="L284" class="LineNr">284 </span>
<span id="L285" class="LineNr">285 </span>
<span id="L286" class="LineNr">286 </span>Function:  Given a list of starnames and regular expressions to match
<span id="L287" class="LineNr">287 </span>and exclude, returns a list of variable names and their values.  Only
<span id="L288" class="LineNr">288 </span>values set by value_$set are returned; see value_$list_data_names to
<span id="L289" class="LineNr">289 </span>list variables set by value_$set_data.
<span id="L290" class="LineNr">290 </span>
<span id="L291" class="LineNr">291 </span>
<span id="L292" class="LineNr">292 </span>Syntax:
<span id="L293" class="LineNr">293 </span>dcl value_$list entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> bit <span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L294" class="LineNr">294 </span>     fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L295" class="LineNr">295 </span>call value_$list <span class="textRainbow_lv0_p0">(</span>seg_ptr<span class="textRainbow_lv0_o0">,</span> switches<span class="textRainbow_lv0_o0">,</span> match_info_ptr<span class="textRainbow_lv0_o0">,</span> area_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L296" class="LineNr">296 </span>     value_list_info_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L297" class="LineNr">297 </span>
<span id="L298" class="LineNr">298 </span>
<span id="L299" class="LineNr">299 </span>Arguments:
<span id="L300" class="LineNr">300 </span>seg_ptr
<span id="L301" class="LineNr">301 </span>   is a pointer to the base of a value segment.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L302" class="LineNr">302 </span>switches
<span id="L303" class="LineNr">303 </span>   is a bit <span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span> word of switches <span class="textRainbow_lv0_p0">(</span>perprocess or permanent<span class="textRainbow_lv0_p0">)</span>. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L304" class="LineNr">304 </span>match_info_ptr
<span id="L305" class="LineNr">305 </span>   is a pointer to a user-allocated structure, declared in
<span id="L306" class="LineNr">306 </span>   value_structures.incl.pl1. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> See &quot;Notes on structures&quot; below.
<span id="L307" class="LineNr">307 </span>area_ptr
<span id="L308" class="LineNr">308 </span>   is a pointer to an area in which the output value_list_info
<span id="L309" class="LineNr">309 </span>   structure is to be allocated. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L310" class="LineNr">310 </span>value_list_info_ptr
<span id="L311" class="LineNr">311 </span>   is a pointer to a structure, allocated by value_$list and freed by
<span id="L312" class="LineNr">312 </span>   the caller when done.  It is also declared in the include file
<span id="L313" class="LineNr">313 </span>   value_structures.incl.pl1. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> See &quot;Notes on structures&quot;.
<span id="L314" class="LineNr">314 </span>code
<span id="L315" class="LineNr">315 </span>   is a standard status code. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L316" class="LineNr">316 </span>
<span id="L317" class="LineNr">317 </span>
<span id="L318" class="LineNr">318 </span>Access required:
<span id="L319" class="LineNr">319 </span>r on the value segment, except for perprocess values.
<span id="L320" class="LineNr">320 </span>
<span id="L321" class="LineNr">321 </span>
<span id="L322" class="LineNr">322 </span>Notes:  Names are returned in alphabetical order.
<span id="L323" class="LineNr">323 </span>
<span id="L324" class="LineNr">324 </span>
<span id="L325" class="LineNr">325 </span>Notes on structures:
<span id="L326" class="LineNr">326 </span>The match_info_ptr argument is a pointer to the following
<span id="L327" class="LineNr">327 </span>user-allocated structure, declared in value_structures.incl.pl1:
<span id="L328" class="LineNr">328 </span>
<span id="L329" class="LineNr">329 </span>   dcl 1 match_info     aligned based <span class="textRainbow_lv0_p0">(</span>match_info_ptr<span class="textRainbow_lv0_p0">)</span>,
<span id="L330" class="LineNr">330 </span>         2 version      fixed bin, /* = 1 */
<span id="L331" class="LineNr">331 </span>         2 name_count   fixed bin,
<span id="L332" class="LineNr">332 </span>         2 max_name_len fixed bin <span class="textRainbow_lv0_p0">(</span>21<span class="textRainbow_lv0_p0">)</span>,
<span id="L333" class="LineNr">333 </span>         2 name_array   <span class="textRainbow_lv0_p0">(</span>alloc_name_count refer
<span id="L334" class="LineNr">334 </span>                         <span class="textRainbow_lv1_p0">(</span>match_info.name_count<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>,
<span id="L335" class="LineNr">335 </span>           3 exclude_sw bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unaligned,
<span id="L336" class="LineNr">336 </span>           3 regexp_sw  bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unaligned,
<span id="L337" class="LineNr">337 </span>           3 pad        bit <span class="textRainbow_lv0_p0">(</span>34<span class="textRainbow_lv0_p0">)</span> unaligned /* = &quot;0&quot;b */
<span id="L338" class="LineNr">338 </span>           3 name char  <span class="textRainbow_lv0_p0">(</span>alloc_max_name_len refer
<span id="L339" class="LineNr">339 </span>                         <span class="textRainbow_lv1_p0">(</span>match_info.max_name_len<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span> varying;
<span id="L340" class="LineNr">340 </span>
<span id="L341" class="LineNr">341 </span>
<span id="L342" class="LineNr">342 </span>If a name's regexp_sw is ON, the name is a regular expression to be
<span id="L343" class="LineNr">343 </span>matched.  Otherwise, it is a starname to be matched.  If the name's
<span id="L344" class="LineNr">344 </span>exclude_sw is ON, variables matching the name are excluded from the
<span id="L345" class="LineNr">345 </span>list built up so far, as for the -exclude control argument to the
<span id="L346" class="LineNr">346 </span>value_list command.  Otherwise, matching variables are added to the
<span id="L347" class="LineNr">347 </span>list.
<span id="L348" class="LineNr">348 </span>
<span id="L349" class="LineNr">349 </span>
<span id="L350" class="LineNr">350 </span>The value_list_info_ptr argument is a pointer to the following
<span id="L351" class="LineNr">351 </span>structure, declared in the include file value_structures.incl.pl1:
<span id="L352" class="LineNr">352 </span>
<span id="L353" class="LineNr">353 </span>   dcl 1 value_list_info   aligned based <span class="textRainbow_lv0_p0">(</span>value_list_info_ptr<span class="textRainbow_lv0_p0">)</span>,
<span id="L354" class="LineNr">354 </span>         2 version         fixed bin,      /* = 1 */
<span id="L355" class="LineNr">355 </span>         2 pair_count      fixed bin,
<span id="L356" class="LineNr">356 </span>         2 chars_len       fixed bin <span class="textRainbow_lv0_p0">(</span>21<span class="textRainbow_lv0_p0">)</span>,
<span id="L357" class="LineNr">357 </span>         2 pairs           <span class="textRainbow_lv0_p0">(</span>alloc_pair_count refer
<span id="L358" class="LineNr">358 </span>                            <span class="textRainbow_lv1_p0">(</span>value_list_info.pair_count<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>,
<span id="L359" class="LineNr">359 </span>           3 type_switches bit <span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span>,
<span id="L360" class="LineNr">360 </span>           3 name_index    fixed bin <span class="textRainbow_lv0_p0">(</span>21<span class="textRainbow_lv0_p0">)</span>,
<span id="L361" class="LineNr">361 </span>           3 name_len      fixed bin <span class="textRainbow_lv0_p0">(</span>21<span class="textRainbow_lv0_p0">)</span>,
<span id="L362" class="LineNr">362 </span>           3 value_index   fixed bin <span class="textRainbow_lv0_p0">(</span>21<span class="textRainbow_lv0_p0">)</span>,
<span id="L363" class="LineNr">363 </span>           3 value_len     fixed bin <span class="textRainbow_lv0_p0">(</span>21<span class="textRainbow_lv0_p0">)</span>,
<span id="L364" class="LineNr">364 </span>         2 chars           <span class="textRainbow_lv0_p0">(</span>alloc_chars_len refer
<span id="L365" class="LineNr">365 </span>                            <span class="textRainbow_lv1_p0">(</span>value_list_info.chars_len<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L366" class="LineNr">366 </span>
<span id="L367" class="LineNr">367 </span>
<span id="L368" class="LineNr">368 </span>For each pair <span class="textRainbow_lv0_p0">(</span>i<span class="textRainbow_lv0_p0">)</span>, the variable name is:
<span id="L369" class="LineNr">369 </span>   substr <span class="textRainbow_lv0_p0">(</span>chars<span class="textRainbow_lv0_o0">,</span> name_index <span class="textRainbow_lv1_p0">(</span>i<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> name_len <span class="textRainbow_lv1_p0">(</span>i<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L370" class="LineNr">370 </span>and the value is:
<span id="L371" class="LineNr">371 </span>   substr <span class="textRainbow_lv0_p0">(</span>chars<span class="textRainbow_lv0_o0">,</span> value_index <span class="textRainbow_lv1_p0">(</span>i<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> value_len <span class="textRainbow_lv1_p0">(</span>i<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L372" class="LineNr">372 </span>
<span id="L373" class="LineNr">373 </span>The first bit in type_switches <span class="textRainbow_lv0_p0">(</span>i<span class="textRainbow_lv0_p0">)</span> is ON if the variable is
<span id="L374" class="LineNr">374 </span>perprocess, the second is ON instead for a variable stored in the
<span id="L375" class="LineNr">375 </span>value segment.
<span id="L376" class="LineNr">376 </span>
<span id="L377" class="LineNr">377 </span>The user is responsible for freeing the value_list_info structure when
<span id="L378" class="LineNr">378 </span>done.
<span id="L379" class="LineNr">379 </span>
<span id="L380" class="LineNr">380 </span>
<span id="L381" class="LineNr">381 </span>:Entry: list_data_names:  04/20/82  value_$list_data_names
<span id="L382" class="LineNr">382 </span>
<span id="L383" class="LineNr">383 </span>Syntax:
<span id="L384" class="LineNr">384 </span>dcl value_$list_data_names entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> bit <span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L385" class="LineNr">385 </span>     fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L386" class="LineNr">386 </span>
<span id="L387" class="LineNr">387 </span>call value_$list_data_names <span class="textRainbow_lv0_p0">(</span>seg_ptr<span class="textRainbow_lv0_o0">,</span> switches<span class="textRainbow_lv0_o0">,</span> match_info_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L388" class="LineNr">388 </span>     area_ptr<span class="textRainbow_lv0_o0">,</span> value_list_info_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L389" class="LineNr">389 </span>
<span id="L390" class="LineNr">390 </span>
<span id="L391" class="LineNr">391 </span>Function: Operates exactly the same as value_$list, but returns
<span id="L392" class="LineNr">392 </span>variables set by value_$set_data instead of value_$set, and does not return
<span id="L393" class="LineNr">393 </span>the values. Instead, it sets value_list_info.value_len to the number of
<span id="L394" class="LineNr">394 </span>words in the value.
<span id="L395" class="LineNr">395 </span>
<span id="L396" class="LineNr">396 </span>
<span id="L397" class="LineNr">397 </span>Arguments:
<span id="L398" class="LineNr">398 </span>   are the same as for value_$list.
<span id="L399" class="LineNr">399 </span>
<span id="L400" class="LineNr">400 </span>
<span id="L401" class="LineNr">401 </span>:Entry: set:  07/16/81  value_$set
<span id="L402" class="LineNr">402 </span>
<span id="L403" class="LineNr">403 </span>
<span id="L404" class="LineNr">404 </span>Function:  defines a value for a name, readable by value_$get.
<span id="L405" class="LineNr">405 </span>
<span id="L406" class="LineNr">406 </span>
<span id="L407" class="LineNr">407 </span>Syntax:
<span id="L408" class="LineNr">408 </span>dcl value_$set entry options <span class="textRainbow_lv0_p0">(</span>variable<span class="textRainbow_lv0_p0">)</span>;
<span id="L409" class="LineNr">409 </span>call value_$set <span class="textRainbow_lv0_p0">(</span>seg_ptr<span class="textRainbow_lv0_o0">,</span> switches<span class="textRainbow_lv0_o0">,</span> name<span class="textRainbow_lv0_o0">,</span> new_value<span class="textRainbow_lv0_o0">,</span> old_value<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L410" class="LineNr">410 </span>
<span id="L411" class="LineNr">411 </span>
<span id="L412" class="LineNr">412 </span>Arguments:
<span id="L413" class="LineNr">413 </span>seg_ptr
<span id="L414" class="LineNr">414 </span>   is a pointer to the base of a value segment. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L415" class="LineNr">415 </span>switches
<span id="L416" class="LineNr">416 </span>   is a bit <span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span> aligned word of switches <span class="textRainbow_lv0_p0">(</span>perprocess or permanent<span class="textRainbow_lv0_p0">)</span>.
<span id="L417" class="LineNr">417 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L418" class="LineNr">418 </span>name
<span id="L419" class="LineNr">419 </span>   is a fixed-length or varying character string.  If fixed-length,
<span id="L420" class="LineNr">420 </span>   trailing blanks are trimmed.  There must be at least one character.
<span id="L421" class="LineNr">421 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L422" class="LineNr">422 </span>new_value
<span id="L423" class="LineNr">423 </span>   is the value to be set, having any data type.  If conversion to the
<span id="L424" class="LineNr">424 </span>   internal character string representation cannot be performed,
<span id="L425" class="LineNr">425 </span>   error_table_$badcall is returned. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L426" class="LineNr">426 </span>
<span id="L427" class="LineNr">427 </span>
<span id="L428" class="LineNr">428 </span>old_value
<span id="L429" class="LineNr">429 </span>   is the current value, having any data type.  If no value is
<span id="L430" class="LineNr">430 </span>   currently defined, the value of this argument is not changed.  If
<span id="L431" class="LineNr">431 </span>   conversion from the internal character string representation cannot
<span id="L432" class="LineNr">432 </span>   be performed, error_table_$bad_conversion is returned. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L433" class="LineNr">433 </span>code
<span id="L434" class="LineNr">434 </span>   is a standard error code.  Having no previous value defined does not
<span id="L435" class="LineNr">435 </span>   cause an error code to be returned.
<span id="L436" class="LineNr">436 </span>
<span id="L437" class="LineNr">437 </span>
<span id="L438" class="LineNr">438 </span>Access required:
<span id="L439" class="LineNr">439 </span>rw to the value segment, except for perprocess values.
<span id="L440" class="LineNr">440 </span>
<span id="L441" class="LineNr">441 </span>
<span id="L442" class="LineNr">442 </span>Notes:  Perprocess values are stored in a temporary value segment in
<span id="L443" class="LineNr">443 </span>the process directory, and disappear when the process terminates.
<span id="L444" class="LineNr">444 </span>
<span id="L445" class="LineNr">445 </span>
<span id="L446" class="LineNr">446 </span>:Entry: set_data:  07/16/81  value_$set_data
<span id="L447" class="LineNr">447 </span>
<span id="L448" class="LineNr">448 </span>
<span id="L449" class="LineNr">449 </span>Function:  defines the value for a name to be a specified number of
<span id="L450" class="LineNr">450 </span>words of data, readable by value_$get_data.  Values set by this
<span id="L451" class="LineNr">451 </span>entrypoint cannot be seen by value_$get or value_$defined.
<span id="L452" class="LineNr">452 </span>
<span id="L453" class="LineNr">453 </span>
<span id="L454" class="LineNr">454 </span>Syntax:
<span id="L455" class="LineNr">455 </span>dcl value_$set_data entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> bit <span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L456" class="LineNr">456 </span>     fixed bin <span class="textRainbow_lv1_p0">(</span>18<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>18<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L457" class="LineNr">457 </span>call value_$set_data <span class="textRainbow_lv0_p0">(</span>seg_ptr<span class="textRainbow_lv0_o0">,</span> switches<span class="textRainbow_lv0_o0">,</span> name<span class="textRainbow_lv0_o0">,</span> new_data_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L458" class="LineNr">458 </span>     new_data_size<span class="textRainbow_lv0_o0">,</span> area_ptr<span class="textRainbow_lv0_o0">,</span> old_data_ptr<span class="textRainbow_lv0_o0">,</span> old_data_size<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L459" class="LineNr">459 </span>
<span id="L460" class="LineNr">460 </span>
<span id="L461" class="LineNr">461 </span>Arguments:
<span id="L462" class="LineNr">462 </span>seg_ptr
<span id="L463" class="LineNr">463 </span>   is a pointer to the base of a value segment. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L464" class="LineNr">464 </span>switches
<span id="L465" class="LineNr">465 </span>   is a bit <span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span> aligned word of switches <span class="textRainbow_lv0_p0">(</span>perprocess or permanent<span class="textRainbow_lv0_p0">)</span>.
<span id="L466" class="LineNr">466 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L467" class="LineNr">467 </span>name
<span id="L468" class="LineNr">468 </span>   is a character string with at least one nonblank character.
<span id="L469" class="LineNr">469 </span>   Trailing blanks are trimmed. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L470" class="LineNr">470 </span>new_data_ptr
<span id="L471" class="LineNr">471 </span>   is a pointer to the value to be set. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L472" class="LineNr">472 </span>new_data_size
<span id="L473" class="LineNr">473 </span>   is the number of words in the value to be set. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L474" class="LineNr">474 </span>
<span id="L475" class="LineNr">475 </span>
<span id="L476" class="LineNr">476 </span>area_ptr
<span id="L477" class="LineNr">477 </span>   if nonnull, points to an area in which the old <span class="textRainbow_lv0_p0">(</span>return<span class="textRainbow_lv0_p0">)</span> value is to
<span id="L478" class="LineNr">478 </span>   be allocated. If null, the old value is not returned. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L479" class="LineNr">479 </span>old_data_ptr
<span id="L480" class="LineNr">480 </span>   is a pointer to the old value. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L481" class="LineNr">481 </span>old_data_size
<span id="L482" class="LineNr">482 </span>   is the number of words returned as the old value. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L483" class="LineNr">483 </span>code
<span id="L484" class="LineNr">484 </span>   is a standard status code.  Having no previous value defined does
<span id="L485" class="LineNr">485 </span>   not cause an error code to be returned. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L486" class="LineNr">486 </span>
<span id="L487" class="LineNr">487 </span>
<span id="L488" class="LineNr">488 </span>Access required:
<span id="L489" class="LineNr">489 </span>rw on the value segment, except for perprocess values.
<span id="L490" class="LineNr">490 </span>
<span id="L491" class="LineNr">491 </span>
<span id="L492" class="LineNr">492 </span>Notes:  Perprocess values are stored in a temporary value segment in
<span id="L493" class="LineNr">493 </span>the process directory, and disappear when the process terminates.
<span id="L494" class="LineNr">494 </span>
<span id="L495" class="LineNr">495 </span>
<span id="L496" class="LineNr">496 </span>:Entry: set_path:  07/16/81  value_$set_path
<span id="L497" class="LineNr">497 </span>
<span id="L498" class="LineNr">498 </span>
<span id="L499" class="LineNr">499 </span>Function:  sets the default value segment used by the value commands
<span id="L500" class="LineNr">500 </span>with no -pathname argument.
<span id="L501" class="LineNr">501 </span>
<span id="L502" class="LineNr">502 </span>
<span id="L503" class="LineNr">503 </span>Syntax:
<span id="L504" class="LineNr">504 </span>dcl value_$set_path entry <span class="textRainbow_lv0_p0">(</span>char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit <span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L505" class="LineNr">505 </span>call value_$set_path entry <span class="textRainbow_lv0_p0">(</span>path<span class="textRainbow_lv0_o0">,</span> create_sw<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L506" class="LineNr">506 </span>
<span id="L507" class="LineNr">507 </span>
<span id="L508" class="LineNr">508 </span>Arguments:
<span id="L509" class="LineNr">509 </span>path
<span id="L510" class="LineNr">510 </span>   is the pathname. The value suffix is assumed. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L511" class="LineNr">511 </span>create_sw
<span id="L512" class="LineNr">512 </span>   is ON to create a value segment if none exists. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L513" class="LineNr">513 </span>code
<span id="L514" class="LineNr">514 </span>   is a standard status code.  If it is error_table_$no_w_permission,
<span id="L515" class="LineNr">515 </span>   the value segment has been set.  Any other nonzero code indicates
<span id="L516" class="LineNr">516 </span>   that the segment was not set. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L517" class="LineNr">517 </span>
<span id="L518" class="LineNr">518 </span>
<span id="L519" class="LineNr">519 </span>:Entry: test_and_set:  07/16/81  value_$test_and_set
<span id="L520" class="LineNr">520 </span>
<span id="L521" class="LineNr">521 </span>
<span id="L522" class="LineNr">522 </span>Function:  defines a new value for a name, only if the name has a
<span id="L523" class="LineNr">523 </span>specified current value.
<span id="L524" class="LineNr">524 </span>
<span id="L525" class="LineNr">525 </span>
<span id="L526" class="LineNr">526 </span>Syntax:
<span id="L527" class="LineNr">527 </span>dcl value_$test_and_set entry options <span class="textRainbow_lv0_p0">(</span>variable<span class="textRainbow_lv0_p0">)</span>;
<span id="L528" class="LineNr">528 </span>call value_$test_and_set <span class="textRainbow_lv0_p0">(</span>seg_ptr<span class="textRainbow_lv0_o0">,</span> switches<span class="textRainbow_lv0_o0">,</span> name<span class="textRainbow_lv0_o0">,</span> new_value<span class="textRainbow_lv0_o0">,</span>
<span id="L529" class="LineNr">529 </span>     old_value<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L530" class="LineNr">530 </span>
<span id="L531" class="LineNr">531 </span>
<span id="L532" class="LineNr">532 </span>Arguments:
<span id="L533" class="LineNr">533 </span>seg_ptr
<span id="L534" class="LineNr">534 </span>   is a pointer to the base of a value segment. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L535" class="LineNr">535 </span>switches
<span id="L536" class="LineNr">536 </span>   is a bit <span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span> aligned word of switches <span class="textRainbow_lv0_p0">(</span>perprocess or permanent<span class="textRainbow_lv0_p0">)</span>.
<span id="L537" class="LineNr">537 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L538" class="LineNr">538 </span>name
<span id="L539" class="LineNr">539 </span>   is a fixed-length or varying character string.  If fixed-length,
<span id="L540" class="LineNr">540 </span>   trailing blanks are trimmed.  There must be at least one character.
<span id="L541" class="LineNr">541 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L542" class="LineNr">542 </span>
<span id="L543" class="LineNr">543 </span>
<span id="L544" class="LineNr">544 </span>new_value
<span id="L545" class="LineNr">545 </span>   is the value to be set, having any data type.  If conversion to the
<span id="L546" class="LineNr">546 </span>   internal character string representation cannot be performed, the
<span id="L547" class="LineNr">547 </span>   error code error_table_$badcall is returned. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L548" class="LineNr">548 </span>old_value
<span id="L549" class="LineNr">549 </span>   is the caller-supplied value that must equal the value currently
<span id="L550" class="LineNr">550 </span>   defined in order for the new value to be set. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L551" class="LineNr">551 </span>code
<span id="L552" class="LineNr">552 </span>   is a standard status code.  It is error_table_$action_not_performed
<span id="L553" class="LineNr">553 </span>   if old_value does not match the currently defined value.
<span id="L554" class="LineNr">554 </span>
<span id="L555" class="LineNr">555 </span>
<span id="L556" class="LineNr">556 </span>Access required:
<span id="L557" class="LineNr">557 </span>rw to the value segment, except for perprocess values.
<span id="L558" class="LineNr">558 </span>
<span id="L559" class="LineNr">559 </span>
<span id="L560" class="LineNr">560 </span>Notes:  If the value tested is perprocess, the value set is also
<span id="L561" class="LineNr">561 </span>perprocess, and vice-versa.
<span id="L562" class="LineNr">562 </span>
<span id="L563" class="LineNr">563 </span>
<span id="L564" class="LineNr">564 </span>:Entry: test_and_set_data:  07/16/81  value_$test_and_set_data
<span id="L565" class="LineNr">565 </span>
<span id="L566" class="LineNr">566 </span>
<span id="L567" class="LineNr">567 </span>Function:  defines the value for a name to be a specified number of
<span id="L568" class="LineNr">568 </span>words of data, readable by value_$get_data, only if the first N words
<span id="L569" class="LineNr">569 </span>of the name's current value have specified contents.
<span id="L570" class="LineNr">570 </span>
<span id="L571" class="LineNr">571 </span>
<span id="L572" class="LineNr">572 </span>Syntax:
<span id="L573" class="LineNr">573 </span>dcl value_$test_and_set_data entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> bit <span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L574" class="LineNr">574 </span>     bin <span class="textRainbow_lv1_p0">(</span>18<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>18<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L575" class="LineNr">575 </span>call value_$test_and_set_data <span class="textRainbow_lv0_p0">(</span>seg_ptr<span class="textRainbow_lv0_o0">,</span> switches<span class="textRainbow_lv0_o0">,</span> name<span class="textRainbow_lv0_o0">,</span> new_data_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L576" class="LineNr">576 </span>     new_data_size<span class="textRainbow_lv0_o0">,</span> old_data_ptr<span class="textRainbow_lv0_o0">,</span> old_data_size<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L577" class="LineNr">577 </span>
<span id="L578" class="LineNr">578 </span>
<span id="L579" class="LineNr">579 </span>Arguments:
<span id="L580" class="LineNr">580 </span>seg_ptr
<span id="L581" class="LineNr">581 </span>   is a pointer to the base of a value segment. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L582" class="LineNr">582 </span>switches
<span id="L583" class="LineNr">583 </span>   is a bit <span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span> aligned word of switches <span class="textRainbow_lv0_p0">(</span>perprocess or permanent<span class="textRainbow_lv0_p0">)</span>.
<span id="L584" class="LineNr">584 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L585" class="LineNr">585 </span>name
<span id="L586" class="LineNr">586 </span>   is a character string with at least one nonblank character.
<span id="L587" class="LineNr">587 </span>   Trailing blanks are trimmed. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L588" class="LineNr">588 </span>new_data_ptr
<span id="L589" class="LineNr">589 </span>   is a pointer to the value to be set.  If null, the current value is
<span id="L590" class="LineNr">590 </span>   deleted and no value is defined. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L591" class="LineNr">591 </span>new_data_size
<span id="L592" class="LineNr">592 </span>   is the number of words in the value to be set. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L593" class="LineNr">593 </span>
<span id="L594" class="LineNr">594 </span>
<span id="L595" class="LineNr">595 </span>old_data_ptr
<span id="L596" class="LineNr">596 </span>   is a pointer to some data, whose first old_data_size words must
<span id="L597" class="LineNr">597 </span>   equal the first old_data_size words of the name's current value in
<span id="L598" class="LineNr">598 </span>   order for the new value to be set. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L599" class="LineNr">599 </span>old_data_size
<span id="L600" class="LineNr">600 </span>   is the number of words to be compared.  This number can be less than
<span id="L601" class="LineNr">601 </span>   the number of words in the name's current value <span class="textRainbow_lv0_p0">(</span>used<span class="textRainbow_lv0_o0">,</span> for example<span class="textRainbow_lv0_o0">,</span>
<span id="L602" class="LineNr">602 </span>   to compare only the header of a structure<span class="textRainbow_lv0_p0">)</span>, but an error code is
<span id="L603" class="LineNr">603 </span>   returned if it is greater. <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L604" class="LineNr">604 </span>code
<span id="L605" class="LineNr">605 </span>   is a standard status code.  It is error_table_$action_not_performed
<span id="L606" class="LineNr">606 </span>   if the old-value match fails. <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L607" class="LineNr">607 </span>
<span id="L608" class="LineNr">608 </span>
<span id="L609" class="LineNr">609 </span>Access required:
<span id="L610" class="LineNr">610 </span>rw on the value segment, except for perprocess values.
<span id="L611" class="LineNr">611 </span>
<span id="L612" class="LineNr">612 </span>
<span id="L613" class="LineNr">613 </span>Notes:  If the value tested is perprocess, the value set is also
<span id="L614" class="LineNr">614 </span>perprocess, and vice-versa.
<span id="L615" class="LineNr">615 </span>
<span id="L616" class="LineNr">616 </span>
<span id="L617" class="LineNr">617 </span>The value of a name can be conditionally deleted by passing a null
<span id="L618" class="LineNr">618 </span>new_data_ptr.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
